/************************************************************************
*Copyright (C) 2003 Elliott Michell					*
*Elliott Mitchell takes no responsibility for failures, or damage done	*
*by this program.							*
*									*
*$Id: rlespace.c,v 1.2 2003/11/10 07:23:37 ehem Exp $			*
*************************************************************************
*One RLE varient. This flavor of RLE was targeted at a particular	*
*flavor of ASCII art (a map on AquaMOO FYI). The encoding is anything	*
*that is !isspace() is simply passed directly through; anything that is	*
*isspace() will be followed by a count of the number of times that	*
*character is repeated.							*
*									*
*Not really that great in the general case, but in the original it only	*
*did spaces (newlines were handled as actual characters) and managed to	*
*shrink the source to one third the original size (I chose an algorithm	*
*that was appropriate, and it worked well). Take a look at fullrle.c	*
*for a more general purpose example.					*
************************************************************************/

#include <stdio.h>
#include <ctype.h>

int main(int argc, char **argv, char **envp)
{
	char *func;
	int buf, tok;
	unsigned char cnt;

	func=*argv+strlen(*argv);
	while(func[-1]!='/'&&func>*argv) --func;

	if(strcmp("unrlespace", func)) {
		buf=getchar();
		while(buf!=EOF) {
			putchar(buf);
			if(!isspace(buf)) buf=getchar();
			else {
				cnt=1;
				tok=buf;
				while(((buf=getchar())==tok)&&cnt) ++cnt;
				/*string of 256 is interesting of course*/
				putchar(cnt);
			}
		}
	} else {
		buf=getchar();
		while(buf!=EOF) {
			putchar(buf);
			if(!isspace(buf)) buf=getchar();
			else {
				if((tok=getchar())==EOF) break; /*fun fun fun*/
				cnt=tok;
				while(--cnt) putchar(buf);
				buf=getchar();
			}
		}
	}
	return(0);
}

